<template>
  <v-app id="inspire">
    <v-navigation-drawer
      v-model="drawer"
      :clipped="$vuetify.breakpoint.lgAndUp"
      primary
      app
    />
    <v-app-bar
      :clipped-left="$vuetify.breakpoint.lgAndUp"
      app
      color="primary"
      dark
    >
      <v-app-bar-nav-icon @click.stop="drawer = !drawer" />
      <v-toolbar-title
        style="width: 300px"
        class="ml-0 pl-4"
      >
        <span class="hidden-sm-and-down">{{ appName }}</span>
      </v-toolbar-title>
      <v-spacer />
      <div v-if="isLoggedIn">
        <v-btn icon>
          <v-icon>mdi-bell</v-icon>
        </v-btn>
        <v-btn
          icon
          large
        >
          <v-avatar
            size="32px"
            item
          >
            <v-img
              src="https://cdn.vuetifyjs.com/images/logos/logo.svg"
              alt="Vuetify"
            />
          </v-avatar>
        </v-btn>
      </div>
      <div v-else>
        <v-btn
          text
          :to="{name: 'Login'}"
        >
          <span class="mr-6">Login</span>
          <v-icon>mdi-account</v-icon>
        </v-btn>
      </div>
    </v-app-bar>
    <v-content>
      <router-view />
    </v-content>
  </v-app>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'

import { appName } from '@/env'
import { readIsLoggedIn } from '@/store/main/getters'
import { dispatchUserLogOut } from '@/store/main/dispatchActions'

// eslint-disable-next-line @typescript-eslint/no-explicit-any
const routeGuardMain = async (to: any, from: any, next: any) => {
  if (to.path === '/main') {
    next('/main/index')
  } else {
    next()
  }
}

@Component
export default class Main extends Vue {
  public appName = appName;
  public drawer = null;

  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  public beforeRouteEnter (to: any, from: any, next: any) {
    routeGuardMain(to, from, next)
  }

  get isLoggedIn () {
    return readIsLoggedIn(this.$store)
  }

  public async logout () {
    await dispatchUserLogOut(this.$store)
  }
}
</script>
